<?php

 /* PNG2FreeSAV - version 0.1-alpha
    A RMMD-tool (Rapid Massive Map Development)
    By Bart Coppens <coppensbart@pi.be>
    Started: 22/10/02
    Last update: 23/10/02
    Function:
      Converts a PNG image to a Freeciv savegame. Rivers, starting locations, etc. are not yet supported
      Use the following colouring scheme:
         a = arctic      = white (#FFFFFF)
         m = mountains   = grey  (#AAAAAA)
         h = hills       = some other green (#007700)
         p = plains      = orange(#ffaf00)
         g = grassland   = green (#00FF00)
         t = tundra      = black (#000000)
         d = desert      = yellow(#FFFF00)
         f = forest      = dark green (#006400)
         s = swamp       = brownish (#969600)
           = ocean       = blue  (#0000FF)
         X = unknown
      Requires:
        PHP >= 4.1.0
        GD2
	A place to put these files
      Files:
        convert.php: Main File, this is called to convert the file
	base-template: all non-map things are stored here.
	options.php: This is the file to edit:
	   - $file: the filename of the PNG image
	   - $version: The Freeciv version
	   - $metastring: The Metastring
	   - $gold: The amount of gold each player recieves at the beginning
	   - $tech: the number of techs each player recieves at the beginning
	   - $minplayers: The minimum number of players required to start a game (should at least be 1)
	   - $maxplayers: The maximum number of players allowed to play this game. You should provide enough starting locations!
	   - $startlocations: For each player, there should be a location. The location consists of an x an y coordinate.
      Notes:
        You probably should tweak the file with CivEdit, as this script only covers very basic things.
	Especially if your map has rivers, CivEdit is recommended.
	No guarantees are made that this script will work or do as it is expected to do. Reminder: this software is alpha.
      Relased under: GNU GPL2
*/


 /* Couldn't remember how I should do this in 1 PHP-command, so I made my own function */
 function leftzeroes($number, $n) {
    for($i = strlen($number); $i < $n; $i++) {
       $number = '0' . $number;
    }
    return $number;
 }

 $colours = Array(
  0xFFFFFF => "a",
  0xAAAAAA => "m",
  0x007700 => "h",
  0xFFAF00 => "p",
  0x00FF00 => "g",
  0x000000 => "t",
  0xFFFF00 => "d",
  0x006400 => "f",
  0x969600 => "s",
  0x0000FF => " "
 );

 include('options.php');


 $fileinfo = getimagesize ($file);
 if ($fileinfo[2] <> 3) { // Accept only PNG
    echo "Only PNG images supported";
    exit();
 }

 $width = $fileinfo[0];
 $height = $fileinfo[1];

 $image = ImageCreateFromPng($file);

 include("base-template");

 $lines_t = Array();
 $lines_n = Array();
 for($i = 0; $i < $height; $i++) {
    $lines_t[$i] = "t" . leftzeroes($i, 3) . '="';
    $lines_n[$i] = "n" . leftzeroes($i, 3) . '="';
    for($j = 0; $j < $width; $j++) {
       $colour = ImageColorAt($image, $j, $i);
       if (IsSet($colours[$colour])) {
          $lines_t[$i] .= $colours[$colour];
       } else {
          $lines_t[$i] .= "X";
       }
       $lines_n[$i] .= "0";
    }
    $lines_t[$i] .= '"';
    $lines_n[$i] .= '"';
    echo $lines_t[$i] . "\n";
 }

 for($i = 0; $i < count($lines_n); $i++) {
    echo $lines_n[$i] . "\n";
 }

?>
